if distance_to_object(obj_player) <= ray_length
{
see_player = false

var add_angle = 5;
var angle_dir = 1; 
var dir = image_angle;

for(var rays = 0; rays <= ray_count; rays ++){
	for(var line_length = 0; line_length < ray_length; line_length ++){
		var xx = x + lengthdir_x(line_length, dir);
		var yy = y + lengthdir_y(line_length, dir);
			
		if position_empty(xx, yy) == false {
			if(instance_place(xx, yy, obj_wall) != noone){
				break;
			}
				
			if(instance_place(xx, yy, obj_player) != noone){
				see_player = true;
				break;
			}
		}
		
		draw_set_color(c_lime);
		draw_point(xx, yy);
	}
	dir += (add_angle * rays) * angle_dir;
	angle_dir *= -1;
}

if(see_player)
{
	var pd = point_direction(x, y, obj_player.x, obj_player.y);
	var dd = angle_difference(image_angle, pd);
	image_angle -= min(abs(dd), detection) * sign(dd);
	
	//sound alert if player is seen for the first time
	if (!alerted)
	{
		audio_play_sound(snd_alert, 1, false);
		alerted = true;
	}
	
	if distance_to_object(obj_player) <= 50{
	detection_level +=  (obj_player.stealth * 0.11);
	}
	else{
		detection_level += (obj_player.stealth * 0.04);
	}
	
	if detection_level >= 50{
	detection = 0.75
	}
	else{
	detection = 0
		}
	speed = 0;
}
else
{
	detection_level -= 0.1;
	alerted = false;
	
}

if (detection_level >= 100)
{
	room_restart()
}

//clamp
detection_level = clamp(detection_level, 0, 100);

//alert
if detection_level >= 50{
	if detection_level <=80{
		alert_frame = 1;
	}
}

if detection_level <= 50{
	alert_frame = 0;
}

if detection_level >= 80{
	alert_frame = 2;
}

}


if (vigilant && !see_player)
{
	if (turn_to_point_1){
		dd1 = angle_difference(image_angle, rotate_angle_1);
	}
	else{
		dd1 = angle_difference(image_angle, rotate_angle_2);
	}
		
	image_angle -= min(abs(dd1), turn_speed) * sign(dd1);
	
	if	(abs(dd1) < 1)
	{
		turn_to_point_1 = !turn_to_point_1;
	}
}

// if in patrol mode and can't see the player, 
// move between two points
if (patrol && !see_player){
	
	if (patrol_1){
		pd1 = point_distance(x, y, X_1, Y_1);
		move_towards_point(X_1, Y_1, 2);
		image_angle = point_direction(x, y, X_1, Y_1);
	}
	else{
		pd1 = point_distance(x, y, X_2, Y_2);
		move_towards_point(X_2, Y_2, 2);
		image_angle = point_direction(x, y, X_2, Y_2);
	}
		
	if	(abs(pd1) < 1)
	{
		patrol_1 = !patrol_1;
	}
}

